<?php
/**
 * 1PS.
 *
 * @package HostCMS
 * @version 6.x
 * @author Hostmake LLC
 * @copyright © 2005-2014 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 */

require_once('../../bootstrap.php');


Core_Auth::authorization('searchinformations');

$sAdminFormAction = '/admin/searchinformations/index.php';

ob_start();

// Контроллер формы
$oAdmin_Form_Controller = Admin_Form_Controller::create();
$oAdmin_Form_Controller
	->setUp()
	->path($sAdminFormAction)
	->title(Core::_('searchinformations.title'));

$oAdmin_Form_Entity_Form = new Admin_Form_Entity_Form($oAdmin_Form_Controller);
$oAdmin_Form_Entity_Form->action($oAdmin_Form_Controller->getPath());
$oAdmin_Form_Entity_Form->enctype('multipart/form-data');


Admin_Form_Entity::factory('Title')
	->name(Core::_('searchinformations.title'))
	->execute();

$sOnClick = false;

$windowId = $oAdmin_Form_Controller->getWindowId();

$aInformationsystemItems = array();

	
$oInfSys = Core_Entity::factory('informationsystem', Core_Array::getRequest('infsys_id', 0));

	$oInformationsystems = Core_Entity::factory('informationsystem');
	$oInformationsystems
			->querybuilder()
			->where('deleted', '=', 0)
			->where('site_id', '=', CURRENT_SITE)
			;

	$aInformationsystems = $oInformationsystems->findAll();

	$options = array();
	foreach ($aInformationsystems as $oInformationsystem) {
		$options[$oInformationsystem->id] = $oInformationsystem->name;
	}
	
	$oSelectInformationsystem = Admin_Form_Entity::factory('select')
		->name('infsys_id')
		->caption('Информационная система')
		->value($oInfSys->id)
		->options($options);
	$oAdmin_Form_Entity_Form->add($oSelectInformationsystem);
	
	$sWord = trim(Core_Array::getRequest('search', ''));
	
	$oSearchWord = Admin_Form_Entity::factory('input')
			->name('search')
			->value($sWord)
			->caption(Core::_('searchinformations.searchword'));
	
	$oAdmin_Form_Entity_Form->add($oSearchWord);
	
	$sOnClick = $oAdmin_Form_Controller->getAdminSendForm('start_search');
	
	$oAdmin_Form_Entity_Form->add(
		Admin_Form_Entity::factory('Button')
		->name('start_search')
		->type('submit')
		->value(Core::_('searchinformations.process'))
		->class('applyButton')
		->onclick($sOnClick)
	);
$oAdmin_Form_Entity_Form
	->action($sAdminFormAction)
	->execute();

if($oAdmin_Form_Controller->getAction() == 'start_search')
{
	
	echo '<h2>'.Core::_('searchinformations.result').'</h2>';

	if ($sWord == '') {
		echo '<p>'.Core::_('searchinformations.nophrase').'</p>';
	}

	if ($sWord != '') {
		
		$oSearchController = SearchInformations_Controller::instance();
		
		$aInformationsystemItems = $oSearchController->search($sWord, $oInfSys);

		if (sizeof($aInformationsystemItems)) {
			$aID = array();

			$code = '<table width="100%" cellpadding="2" cellspacing="2" class="admin_table">';
			$code .= '<tr class="admin_table_title"><td width="40px" align="center">'.Core::_('searchinformations.id').'</td><td>'.Core::_('searchinformations.name').'</td><td>'.Core::_('searchinformations.actions').'</td>';
			foreach ($aInformationsystemItems as $oInformationsystemItem) {
				$code .= '<tr>';
				$code .= "<td align=\"center\">{$oInformationsystemItem->id}</td>";
				$code .= "<td>{$oInformationsystemItem->name}</td>";
				$code .= '<td width="40px" align="center"><img src="/admin/images/edit.gif" class="pointer left5px" id="editXsl_88_21" onclick="$.openWindow({path: \'/admin/informationsystem/item/index.php\', additionalParams: \'informationsystem_id='.$oInformationsystemItem->informationsystem_id.'&informationsystem_group_id='.$oInformationsystemItem->informationsystem_group_id.'&hostcms[checked][1]['.$oInformationsystemItem->id.']=1&hostcms[action]=edit\'})"/></td>';
				$code .= '</tr>';
			}
			$code .= '</table>';
			echo $code;
		} else {
			echo Core::_('searchinformations.nothing');
		}
	}
}

$oAdmin_Answer = Core_Skin::instance()->answer();

$oAdmin_Answer
	->ajax(Core_Array::getRequest('_', FALSE))
	->content(ob_get_clean())
	->message('')
	->title(Core::_('searchinformations.title'))
	->execute();