<?php

class SearchInformations_Controller {

	/**
	 * The singleton instances.
	 * @var mixed
	 */
	static public $instance = NULL;

	/**
	 * Register an existing instance as a singleton.
	 * @return object
	 */
	static public function instance()
	{
		if (is_null(self::$instance))
		{
			self::$instance = new self();
		}

		return self::$instance;
	}
	
	/**
	 * Get list of columns in a table
	 *
	 * @param string $tableName Table name
	 * @return array
	 */
	private function _getColumns($tableName) {
		
		$aTableColumns = array();
		
		$sql = "SHOW COLUMNS FROM {$tableName} WHERE `Type` = 'text' OR `Type` = 'mediumtext' OR `Type` =  'longtext' OR `Type` LIKE 'varchar%'";
		
		$aTableColumns = Core_DataBase::instance()->query($sql)->asAssoc()->result();
		
		return $aTableColumns;
	}
	
	public function search($sWord, $oInfSys) {
				// Additional properties
		$oInformationsystem_Item_Property_List = Core_Entity::factory('Informationsystem_Item_Property_List', $oInfSys->id);

		$oProperties = $oInformationsystem_Item_Property_List->Properties;
		$oProperties->querybuilder()
			->where('type', 'IN', array(1, 4));
		$aProperties = $oProperties->findAll();

		$aTmpProperties = array();
		$havingCount = 0;
		foreach ($aProperties as $oProperty)
		{
			// Св-во может иметь несколько значений
			$aTmpProperties[] = array($oProperty, $sWord);
			$havingCount++;
		}
		
		$oInformationsystemItems = Core_Entity::factory('informationsystem_item');

		if (count($aTmpProperties)) {
			$oInformationsystemItems->queryBuilder()
				->leftJoin('informationsystem_item_properties', 'informationsystem_items.informationsystem_id', '=', 'informationsystem_item_properties.informationsystem_id')
				->setAnd();
		}

		$oInformationsystemItems->queryBuilder()
			->where('informationsystem_items.informationsystem_id', '=', $oInfSys->id);

		$aTableColumns = $this->_getColumns('informationsystem_items');

		$countColumns = sizeof($aTableColumns) - 1;
		$oInformationsystemItems->queryBuilder()->open();
		foreach ($aTableColumns as $pos => $aColumn) {
			$oInformationsystemItems->queryBuilder()->where("informationsystem_items.{$aColumn['Field']}", 'LIKE', "%{$sWord}%");
			if ($countColumns > $pos) {
				$oInformationsystemItems->queryBuilder()->setOr();
			}
		}
		$oInformationsystemItems->queryBuilder()->close();
		
		$close = false;

		if (count($aTmpProperties))
		{
			$aTableNames = array();

			reset($aTmpProperties);

			$close = true;

			$oInformationsystemItems->queryBuilder()->setOr();

			$oInformationsystemItems->queryBuilder()->open();

			while(list(, list($oProperty, $propertyValue)) = each($aTmpProperties))
			{
				$tableName = $oProperty->createNewValue(0)->getTableName();

				!in_array($tableName, $aTableNames) && $aTableNames[] = $tableName;

				if (!is_array($propertyValue))
				{

					// Для строк фильтр LIKE %...%

						$oInformationsystemItems->queryBuilder()
							->where('informationsystem_item_properties.property_id', '=', $oProperty->id);
						$oInformationsystemItems->queryBuilder()
							->where($tableName . '.value', 'LIKE', "%{$propertyValue}%");

						$oInformationsystemItems->queryBuilder()
							->setOr();

				} else {

				}
			}

			foreach ($aTableNames as $tableName)
			{
				$oInformationsystemItems->queryBuilder()
					->leftJoin($tableName, 'informationsystem_items.id', '=', $tableName . '.entity_id',
						array(
							array('AND' => array('informationsystem_item_properties.property_id', '=', Core_QueryBuilder::expression($tableName . '.property_id')))
						)
					);
			}
		}

		if ($close) {
		$oInformationsystemItems->queryBuilder()
			->close();
		}
		$oInformationsystemItems->queryBuilder()->groupBy('informationsystem_items.id');
		
		$aInformationsystemItems = $oInformationsystemItems->findAll();
		
		return $aInformationsystemItems;
	}
}
